<?php
// Статистика посещения чата CommFort от Ярослава
$version = 'v2.3.2';
// Обсуждение тут: http://commfort.com/ru/forum/viewtopic.php?f=11&t=6204
// ======================================================================
// Секция настроек:
// ======================================================================
$settings['site_url'] = 'http://commfort.com'; // Ссылка на ваш сайт, где можно получить информацию о сервере.

// Список адресов, которые считаются локальными клиентами. Нужно указать первые цифры адреса.
// Указывайте только нужные шаблоны. К примеру, если адреса 10.* у вас в сети не встречаются, то закомментируйте эту строку.
// Это ускорит работу скрипта.
$settings['local_addresses'][] = '192.168.';
$settings['local_addresses'][] = '10.';
$settings['local_addresses'][] = '127.';
$settings['local_addresses'][] = '93.79.';
//$settings['local_addresses'][] = '169.254.';
//$settings['local_addresses'][] = '172.16.';
//$settings['local_addresses'][] = '172.17.';
//$settings['local_addresses'][] = '172.18.';
//$settings['local_addresses'][] = '172.19.';
//$settings['local_addresses'][] = '172.2';
//$settings['local_addresses'][] = '172.30.';
//$settings['local_addresses'][] = '172.31.';

$settings['port'] = '9750'; // Порт чата

//$settings['ub_source_image'] = 'source.png'; // Исходная картинка для фона юзербара.
$settings['ub_background'] = '#FAFAFA'; // Цвет фона юзербара. Используется только если нет фонового изображения ^^^^^^^
$settings['ub_font_color'] = '#E90E5B'; // Цвет текста юзербара
$settings['ub_font_size'] = '10'; // Размер шрифта выводимого текста
$settings['ub_line_length'] = '350'; // Длина линии подчеркивания в пикселах

$settings['auto_refresh'] = 60; // Время в секундах, через которое будет автообновляться iframe. Не рекомендуется ставить меньше, чем половина срока кеширования. Для отключения поставить false

/**
 * Поставить true, если нужно снимать статистику с удалённого сервера
 * Для этого на удалённом сервере нужно включить службу telnet
 * net start telnet
 * или Пуск —> Выполнить... —> services.msc в списке найти эту службу и настроить на автоматический запуск
 * Подробности на форуме
 */
//$settings['remote_stat'] = true;
$settings['remote_stat'] = false;

/**
 * Эти настройки имеют смысл только в том случае, если $settings['remote_stat'] = true;
 * Т.е. если вы снимаете статистику с удалённого сервера. 
 */
$settings['remote_addr'] = '192.168.1.1';
$settings['remote_port'] = '23';
// Логин и пароль одного из пользователей удалённого компьютера, кто имеет право ходить на телнет
$settings['remote_user'] = 'login';
$settings['remote_pass'] = 'password';
$settings['cache_ttl'] = 5*60; // Время жизни кеша в секундах. Нагляднее всего указывать в виде произведения.
                                // 2 часа выглядит так: 2*60*60
                                // 15*60 — 15 минут
                                // 0 — кеширование отключено
                                // При пером запросе будет создан файл кеша и статистика не будет запрашиваться, пока не пройдёт указанное время.
$settings['cache_file'] = 'statcache.txt'; // Название файла кеша (можно указывать абсолютный или относительный путь)

// ======================================================================
// Далее ничего не менять
// ======================================================================

$settings['netstat_cmd'] = 'netstat -n -p TCP'; // Команда для сбора статистики. Менять только если понимаешь, что делаешь!

function rgb2array($rgb) {
    if ($rgb[0] == '#' || strlen($rgb) == 7){
        return array(
            base_convert(substr($rgb, 1, 2), 16, 10),
            base_convert(substr($rgb, 3, 2), 16, 10),
            base_convert(substr($rgb, 5, 2), 16, 10),
        );
    } else {
        return array(80,80,80);
    }
}

function collect_remote(){
    global $settings;
    require_once('PHPTelnet.php');

    $script = new Telnet;
    $script->set_host($settings['remote_addr']);
    $script->set_port($settings['remote_port']);
    $script->set_prompt(">");
    if ($script->connect() != TELNET_OK){
        die("Connection error");
    }
    if ($script->read_to(': ') != TELNET_OK){
		die("Can't find login request. Last lines: ".$script->get_buffer());
	}
    $script->write($settings['remote_user'].PHP_EOL,null,false);
    if ($script->read_to(': ') != TELNET_OK){
		die("Can't find password request. Last lines: ".$script->get_buffer());
	}
	$script->write($settings['remote_pass'].PHP_EOL,null,false);
    if ($script->wait_prompt() != TELNET_OK){
		die("Login failed or prompt char is not ".$script->prompt.' Last lines: '.$script->get_buffer());
	}
    $script->write($settings['netstat_cmd'].PHP_EOL);
    $script->wait_prompt();
    $out = explode(PHP_EOL,$script->get_buffer());
    $script->disconnect();
    return $out;
}

function collect_local(){
    global $settings;
    exec($settings['netstat_cmd'],$out);
    return $out;
}

$out = $matches = array();
$users = $inet = $cachedate = 0;

if ($cache = @file($settings['cache_file'], FILE_IGNORE_NEW_LINES)){
    list($cachedate, $users, $inet) = $cache;
}

if ((time() - $cachedate) > $settings['cache_ttl']){
$users = $inet = $local = 0;

    if (!empty($settings['remote_stat'])){
        $out = collect_remote();
    } else {
        $out = collect_local();
    }
    
    $pattern = sprintf('/TCP\s*(?:[0-9]*\s*[0-9]*\s*)?[0-9.]{7,15}\:%s\s*([0-9.]*)\:(\d*)\s*ESTABLISHED/iU', $settings['port']);
    foreach ($out as $conn){
        if (preg_match($pattern,$conn,$matches)){
            $users++;
            foreach ($settings['local_addresses'] as $addr) {
               if (strpos($matches[1], $addr) === 0){
                   $local++;
                   break;
               }
            }
        }
    }
    $inet = $users - $local;
    file_put_contents($settings['cache_file'], time() . "\n" . $users . "\n" . $inet);
}

isset($_GET['t'])?$type = $_GET['t']:$type='page';

switch ($type){
    case 'userbar':
        header ('Content-type: image/png');
	    if (!empty($settings['ub_source_image'])) {
            if ($image_info = @getimagesize($settings['ub_source_image'])){
				$creator = 'imagecreatefrom'.end(explode('/',$image_info['mime']));
				$im = $creator($settings['ub_source_image']);
			}
		}
		if (empty($im)){
			$im = imagecreatetruecolor(350, 20);
            $color = rgb2array($settings['ub_background']);
            $bg_color = imagecolorallocate($im, $color[0], $color[1], $color[2]);
            imagefill($im, 0, 0, $bg_color);
		}
        $logo = imagecreatefromgif('logo.gif');
        $color = rgb2array($settings['ub_font_color']);
        $text_color = imagecolorallocate($im, $color[0], $color[1], $color[2]);
        $font = 'tahomabd.ttf';
        $text = 'Народа в CommFort\'e: '.$users.'. Из них из инета: '.$inet;

        imagecopy($im, $logo, 1, 2, 0, 0, 16, 16);
        imagettftext($im, $settings['ub_font_size'], 0, 18, 16, $text_color, $font, $text);
        imageline($im, 4, 18, $settings['ub_line_length']+4, 18, $text_color);
        imagepng($im);
        imagedestroy($im);
    break;
    case 'text':
        header('Content-Type: text/html; charset=UTF-8');
        $text = 'Народа в CommFort\'e: '.$users.'. Из них из инета: '.$inet;
        ?>
<html><head>
<?php if($settings['auto_refresh']): ?><meta http-equiv="refresh" content="<?=$settings['auto_refresh']?>" ><?php endif;?>
</head>
<body><div class='commfort_stat'><?=$text?></div></body></html>
        <?php
    break;
    case 'page':
    default:
        header('Content-Type: text/html; charset=UTF-8');
        $current_location = ($_SERVER['HTTPS']?'https://':'http://').$_SERVER['HTTP_HOST'].($_SERVER['SERVER_PORT']=='80'?'':':'.$_SERVER['SERVER_PORT']);
        $script_uri = $current_location.$_SERVER['PHP_SELF'];
        $img_uri = $current_location.dirname($_SERVER['PHP_SELF']).'/stat.png';
        ?>
<html><head>
<title>Commfort Stats</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
</head><body>
<h1>Статистика посещаемости чата CommFort от Ярослава. <?=$version?></h1>
<p>В последующих версиях тут будет статистика, возможно даже график :). Но пока система показывает только текущее количество людей в чате без сохранения.</p>
<?php if ($settings['cache_ttl'] > 0) :?>
<p style="color:red;font-weight:600;">Внимание! Включено кеширование результатов. Статистика будет обновляться раз в <?=date('i минут s секунд',$settings['cache_ttl'])?>.
</p> Последнее обновление <?=date('i минут s секунд',(time() - $cachedate))?> назад.
<?php endif;?>
<p>Для вывода информации на свой сайт в виде блока используйте:</p>
<textarea cols="70" rows="5" onclick="this.select();" readonly="readonly">&lt;iframe width="200px" height="100px" src="<?=$script_uri?>?t=text"&gt;Только самый отстойный браузер в наше время может не поддерживать iframe и вы как раз его используете.&lt;/iframe&gt;</textarea>
<br />Пример:<br />
<iframe width="200px" height="100px" src="<?=$script_uri?>?t=text">Только самый отстойный браузер в наше время может не поддерживать iframe и вы как раз его используете.</iframe>
<p>Для вставки картинки на страницу в HTML используйте:</p>
<textarea cols="70" rows="5" onclick="this.select();" readonly="readonly">&lt;img src=<?=$img_uri?> /&gt;</textarea>
<p>Для вставки картинки в подпись BB-кодами на форуме используйте:</p>
<textarea cols="70" rows="5" onclick="this.select();" readonly="readonly">[CENTER][URL="<?=$settings['site_url']?>"][IMG]<?=$img_uri?>[/IMG][/URL][/CENTER]</textarea>
<br><br>Если не работает .htaccess файл (примеры не показывают картинку), то вместо <strong>stat.png</strong> нужно использовать <strong>index.php?t=userbar</strong>, но в таком варианте на форум вставить скорее всего не получится.
Ну или проверить настройки для данной директории в кофигурации вебсервера. Директива <a href="http://httpd.apache.org/docs/2.2/mod/core.html#allowoverride">AllowOwerride</a>.
<br />Пример:<br />
<img src=<?=$img_uri?> />
</body></html>
        <?php
}
?>